Attribute VB_Name = "Module1"

'-------------------------------------------
'
' BMPt@C炨G`WbNHTML
'
'-------------------------------------------


Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Const CacheForValue = 1024
Const IMAGE_BITMAP = 0&
Const LR_LOADFROMFILE = &H10
Const LR_CREATEDIBSECTION = &H2000

Type BITMAP
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

'init@C
Public Const IniFile = "bmplogic.ini"

'Oݒ
Public SplitRowChar As String
Public SplitColChar As String
Public EmptyColor As String
Public FillColor As String
Public CellSize As String
Public BorderStyle As String


Sub Main()
'HTMLt@C쐬
Dim BMPPath As String
Dim HTMLPath As String
Dim temp() As String
Dim b As Boolean
Dim buf() As Long, buf2() As Long 'Qobt@
Dim TextRow() As String, TextCol() As String

'On Error GoTo trap

BMPPath = Command


't@C`FbN
If BMPPath = "" Or Dir(BMPPath) = "" Then
  MsgBox "t@ChbOĂ"
  Exit Sub
End If

HTMLPath = RemoveExtension(BMPPath) + ".html"


'BMP̂Qz擾
b = GetBMPMatrix(BMPPath, buf)
If Not b Then
  MsgBox "BMPt@Cǂ݂߂܂"
  Exit Sub
End If


'32bit1bitɕϊ
Call ConverttoBinary(buf, buf2)

'Init@Cݒǂ݂
Call ReadSettingsFromIni

'A}XJEg
Call GetCountString(buf2, TextRow, TextCol)


'HTMLɏo
Call OutputHTML(HTMLPath, buf2, TextRow, TextCol)

End Sub



Function GetBMPMatrix(ByVal BMPFile As String, buf() As Long) As Boolean
'BMPQzɗ
Dim SrcDC As Long, oldDIB As Long
Dim DestDIBSec As DIBSec
Dim hDIB As Long
Dim b As Long
Dim bm As BITMAP
Dim t() As Long
Dim i&, j&

hDIB = LoadImage(0, BMPFile, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE + LR_CREATEDIBSECTION)

b = GetObject(hDIB, Len(bm), bm)
'ǂ݂ݎs
If b = 0 Then
  Call DeleteObject(hDIB)
  Exit Function
End If

'DC
SrcDC = CreateCompatibleDC(0)
oldDIB = SelectObject(SrcDC, hDIB)

'32bitDIB
DestDIBSec = DIBSecCreate(0, 32, bm.bmWidth, bm.bmHeight, t)

'bitblt
Call BitBlt(DestDIBSec.hdc, 0, 0, bm.bmWidth, bm.bmHeight, SrcDC, 0, 0, SrcCopy)

'폜
Call SelectObject(SrcDC, oldDIB)
Call DeleteObject(SrcDC)
Call DeleteObject(hDIB)

'obt@
ReDim buf(bm.bmWidth - 1, bm.bmHeight - 1) As Long
For i = 0 To bm.bmHeight - 1
  Call CopyPtrtoVal(buf(0, bm.bmHeight - 1 - i), DestDIBSec.hMem + DestDIBSec.LineLength * i, 4 * DestDIBSec.Width)
  For j = 0 To bm.bmWidth - 1
    buf(j, bm.bmHeight - 1 - i) = buf(j, bm.bmHeight - 1 - i) And &HFFFFFF
  Next
Next

Call DIBSecDelete(DestDIBSec)

GetBMPMatrix = True

End Function


Sub ConverttoBinary(Srcbuf() As Long, Destbuf() As Long)
'1bit̒lɗ

'24bit1bitɗ
ReDim Destbuf(UBound(Srcbuf, 1), UBound(Srcbuf, 2)) As Long
For i = 0 To UBound(Srcbuf, 1)
  For j = 0 To UBound(Srcbuf, 2)
    R = (Srcbuf(i, j) And &HFF0000) \ &H10000
    G = (Srcbuf(i, j) And &HFF00&) \ &H100
    b = Srcbuf(i, j) And &HFF
    'ςĖ邯0AÂ1
    Destbuf(i, j) = IIf(R + G + b > 128 * 3, 0, 1)
  Next
Next


End Sub

Sub ReadSettingsFromIni()
Dim IniPath As String
IniPath = App.Path
If Right(IniPath, 1) <> "\" Then IniPath = IniPath + "\"
IniPath = IniPath + IniFile


SplitRowChar = GetIni("Settings", "SplitRowChar", " ", IniPath)
If SplitRowChar = "" Then
  SplitRowChar = " "
End If
SplitColChar = GetIni("Settings", "SplitColChar", "<BR>", IniPath)
If SplitColChar = "" Then
  SplitColChar = " "
End If
EmptyColor = GetIni("Settings", "EmptyColor", "#FFFFFF", IniPath)
FillColor = GetIni("Settings", "FillColor", "#000000", IniPath)
CellSize = GetIni("Settings", "CellSize", "14", IniPath)
BorderStyle = GetIni("Settings", "BorderStyle", "border=1", IniPath)



End Sub


Sub GetCountString(buf() As Long, TextRow() As String, TextCol() As String)
'A}XJEgAŕԂ
Dim i&, j&, k&, R&, G&, b&, cnt&, x&, y&


'lꗗ
ReDim TextRow(UBound(buf, 2)) As String
ReDim TextCol(UBound(buf, 1)) As String

'T[`
For y = 0 To UBound(buf, 2)
  cnt = 0
  For x = 0 To UBound(buf, 1)
    If buf(x, y) = 1 Then
      cnt = cnt + 1
    Else
      If cnt > 0 Then
        TextRow(y) = IIf(TextRow(y) = "", CStr(cnt), TextRow(y) + SplitRowChar + CStr(cnt))
        cnt = 0
      End If
    End If
  Next
  If cnt > 0 Then
    TextRow(y) = IIf(TextRow(y) = "", CStr(cnt), TextRow(y) + SplitRowChar + CStr(cnt))
  End If
  TextRow(y) = IIf(TextRow(y) = "", "&nbsp", TextRow(y))
Next

'cT[`
For x = 0 To UBound(buf, 1)
  cnt = 0
  For y = 0 To UBound(buf, 2)
    If buf(x, y) = 1 Then
      cnt = cnt + 1
    Else
      If cnt > 0 Then
        TextCol(x) = IIf(TextCol(x) = "", CStr(cnt), TextCol(x) + SplitColChar + CStr(cnt))
        cnt = 0
      End If
    End If
  Next
  If cnt > 0 Then
    TextCol(x) = IIf(TextCol(x) = "", CStr(cnt), TextCol(x) + SplitColChar + CStr(cnt))
  End If
  TextCol(x) = IIf(TextCol(x) = "", "&nbsp", TextCol(x))
Next

End Sub


Sub OutputHTML(ByVal HTMLFile As String, buf() As Long, TextRow() As String, TextCol() As String)
'ŏIIHTML
Dim fn&
Dim i&, j&, k&, x&, y&, l&

fn = FreeFile
Open HTMLFile For Output As fn

For l = 0 To 1

  'wb_
  Print #fn, "<TABLE " + BorderStyle + ">"
  
  'Ps
  Print #fn, "<TR><TD>@</TD>"
  
  'Psڐl
  For x = 0 To UBound(buf, 1)
    Print #fn, "<TD valign=""bottom"" align=""center"" width=""" + CellSize + """>" + TextCol(x) + "</td>"
  Next
  
  Print #fn, "</TR>"
  
  'Qsځ`Ō܂
  For y = 0 To UBound(buf, 2)
    'esl
    Print #fn, "<TR height=""" + CellSize + """><TD align=""right"">" + TextRow(y) + "</TD>"
    'e
    For x = 0 To UBound(buf, 1)
      If l = 0 Then
        'Pڂ̋󔒕\
        Print #fn, "<TD>&nbsp</TD>"
      Else
        'Qڂ̉𓚕\
        If buf(x, y) > 0 Then
          'hԂ
          Print #fn, "<TD bgcolor=""" + FillColor + """>@</TD>"
        Else
          '󔒃}X
          Print #fn, "<TD bgcolor=""" + EmptyColor + """>@</TD>"
        End If
      End If
    Next
    
    Print #fn, "</TR>"
  Next
  
  Print #fn, "</TABLE><P>"
Next

Close



End Sub


Function RemoveExtension(FileName As String) As String
't@Cgq菜
Dim i&

For a = Len(FileName) To 1 Step -1
  If Mid(FileName, a, 1) = "." Then '납u . vTĂ
    RemoveExtension = Left(FileName, a - 1)
    Exit Function
  End If
Next

End Function


Function GetIni(ByVal SectionName As String, ByVal Key As String, ByVal Default As String, ByVal FileName As String) As String 'iniǂݍ
'f[^擾

Dim s As String, i As Long

'ꎞobt@m
s = String(CacheForValue, " ")

'ǂݍ
Call GetPrivateProfileString(SectionName, Key, Default, s, Len(s), FileName)

'NULL폜
i = InStr(s, vbNullChar)
If i = 0 Then
  GetIni = ""
Else
  GetIni = Left(s, i - 1)
End If

End Function

